
###################
#DEBUT PARAMETRAGE: A parametrer ici avant de lancer le script
###################

# nombre de bande du spectre
nbSampleOut=32

# nom du fichier audio (attention le fichier doit etre un wav, stereo, 16 bits)
filename = 'c:\Documents and Settings\Jean-Baptiste\Mes documents\extraitPresse.wav'

###################
#FIN PARAMETRAGE.
###################




import wave
import fft
from fft import *
import Array
from Array import *
import math
from math import *
import Blender
from Blender import *





scn=Scene.GetCurrent()
def names(ob): return ob.getName()

def toSignedInt(val1,val2):
	int1 = ord(val1)
	lentier = ord(val1)*256 + ord(val2)
	if int1 & 0x80 :
		lentier=-2**16+lentier
	return lentier


#########
# Cette fonction renvoie un empty 
# in  : objname : le nom de l'empty recherche
# out : myobj : l'empty cree ou retrouve
#########
def GetOrCreateEmpty(objname):
	objects = Blender.Object.Get()
	if objname in map(names,objects):
		myobj = Blender.Object.Get(objname)
		print objname+' exists'
	else:
		myobj = Blender.Object.New('Empty',objname)

		scn.link(myobj)	
		print objname+' was created'
	return myobj

def eraseIPO (objectname):
	object = Blender.Object.Get(objectname)
	lIpo = object.getIpo()
	if lIpo != None:
		nbCurves = lIpo.getNcurves()
 		for i in range(nbCurves):
			nbBezPoints = lIpo.getNBezPoints(i)
			for j in range(nbBezPoints):
				lIpo.delBezPoint(i)

def GetOrCreateIPO(name):

	ipos = Blender.Ipo.Get()
	if name in map(names,ipos):
		myipo = Blender.Ipo.Get(name)
		print name+' exists'
	else:
		myipo = Blender.Ipo.New('Object',name)
		print name+' was created'
	return myipo


def GetOrCreateCurve(ipo, curvename):
	curves = ipo.getCurves()
	if curvename in map(names,curves):
		mycurve = ipo.getCurve(curvename)
		print curvename+' exists'
	else:
		mycurve = ipo.addCurve(curvename)
		print curvename+' was created'
	return mycurve


print "*** START ****"

nbSampleIn=256


#lecture du fichier son
fin = wave.open(filename, 'rb')
smpWidth = fin.getsampwidth()
frameRate = fin.getframerate()
nbFrames = fin.getnframes()
print fin.getparams()
str1=fin.readframes(nbFrames)
fin.close()
print len(str1)
#print fin.getparams()

# calcul du nombre d'echantilon par images
context=scn.getRenderingContext()
frmprsec = context.framesPerSec()
nbsmpperframe = frameRate/frmprsec
print "nbsmpperframe = ",  nbsmpperframe


#calcul de la puissance de 2 directement suprieure 
pow2=1
while (pow2<nbsmpperframe):
	pow2=pow2*2
#pow2=pow2/2
#pow2=256
print "pow2= ", pow2


#creation des tableaux de communication avec la librairie C
Crchan = Array()
Clchan = Array()
Crchan.Init(pow2)
Clchan.Init(pow2)
Cspectre = Array()
Cspectre.Init(nbSampleOut) 


#creation des empties et des ipo associees
empties = []
ipos = []
curves = []
for i in range(nbSampleOut):
	empties.append(GetOrCreateEmpty ("em"+str(i)))
	empties[i].setLocation(float(i), 0.0, 0.0)

	eraseIPO (empties[i].getName())
	ipos.append(GetOrCreateIPO(empties[i].getName()))
	empties[i].setIpo(ipos[i])
	curves.append(ipos[i].addCurve('LocZ'))
	curves[i].setInterpolation('Linear')
	curves[i].setExtrapolation('Constant')
	
rsignal=[]
lsignal=[]
for i in range(0,len(str1),4):
	lsignal.append(float(toSignedInt(str1[i+1],str1[i]))/32768.0)
	rsignal.append(float(toSignedInt(str1[i+3],str1[i+2]))/32768.0)
	
#print lchan
#print rchan
# Pour chaque image, on calcule le spectre a afficher
k=0
numframe = Blender.Get("curframe")

while (k<nbFrames-pow2 and numframe<Blender.Get("endframe")):
	# remplissage des tableaux de donnees
	if (1==1):
		for l in range(pow2):
			val1 = lsignal[k+l]
			#val1 = sin (l*(2.3*pi)/pow2)#+sin (l*(112.45*pi)/pow2)
			val2 = rsignal[k+l]
			#print "idx = ", l, "k = ", k ," val1 = ",val1
			Clchan.setElement(l, val1)
			Crchan.setElement(l, val2)
	else:
		for l in range(pow2):
			val1 = sin (l*(2.3*pi)/pow2)#+sin (l*(112.45*pi)/pow2)
			Clchan.setElement(l, val1)
			Crchan.setElement(l, val1)


	# calcul du spectre
	FFT(0, pow2, nbSampleOut, Clchan.getData(), Cspectre.getData());

	spectre = []
	for i in range (nbSampleOut):
		spectre.append(Cspectre.getElement(i))
	#print spectre	

	for i in range (nbSampleOut):
		curves[i].addBezier((numframe, spectre[i]/3.0))

	numframe=numframe+1

	k=k+nbsmpperframe


Redraw()
#liberation memoire
Clchan.dispose()
Crchan.dispose()
Cspectre.dispose()

print "*** STOP ****"



#idx=0
#for i in  range(nbSampleIn):
#	val = sin (i*(2*pi)/nbSampleIn)
#	print val
#	Clchan.setElement(idx,val)
#	Crchan.setElement(idx,val)
#	idx+=1

#rchan=[]
#lchan=[]
#for i in range(0,nbSampleIn-1,4):
#	lchan.append(float(toSignedInt(str1[i+1],str1[i])))
#	rchan.append(float(toSignedInt(str1[i+3],str1[i+2])))
#	idx+=1
# remplissage des tableaux de donnees
#idx = 0;
#for i in range(0,len(str1)-1,4):
#	val1 = float(toSignedInt(str1[i+1],str1[i]))/32768.0
#	val2 = float(toSignedInt(str1[i+3],str1[i+2]))/32768.0
	#print "idx = ", idx, " i = ", i, "val1= ", val1 
#	Clchan.setElement(idx, val1)
#	Crchan.setElement(idx, val2)
#	idx+=1

# calcul du spectre
#FFT(0, nbSampleIn, nbSampleOut, Clchan.getData(), Cspectre.getData());

#spectre = []
#for i in range (nbSampleOut):
#	spectre.append(Cspectre.getElement(i))
#print spectre